#include <glib.h>
#include <gtk/gtk.h>
#include "pixmaps.h"

#include "pixmaps/gem.xpm"
#include "pixmaps/target.xpm"
#include "pixmaps/wall.xpm"
#include "pixmaps/background.xpm"
#include "pixmaps/player.xpm"

#include "pixmaps/backward.xpm"
/* #include "pixmaps/backward10.xpm" */
#include "pixmaps/backward5.xpm"
#include "pixmaps/first.xpm"
#include "pixmaps/forward.xpm"
/* #include "pixmaps/forward10.xpm" */
#include "pixmaps/forward5.xpm"
#include "pixmaps/last.xpm"
/* #include "pixmaps/quit.xpm" */

#include "pixmaps/player_target.xpm"
#include "pixmaps/gem_target.xpm"

#include "pixmaps/Gun.xpm"
#include "pixmaps/Beer.xpm"
#include "pixmaps/Fish.xpm"
#include "pixmaps/HandOpen.xpm"

GdkPixmap *Tool_Pixmap[ 5 ];
GdkPixmap *Control_Pixmap[ 6 ];
GdkBitmap *Control_Mask[ 6 ];
GdkPixmap *Case_Pixmap[ 14 ];
GdkPixmap *Dialog_Pixmap[ 4 ];
GdkBitmap *Dialog_Mask[ 4 ];

#define build_pixmap(_data) \
  gdk_pixmap_create_from_xpm_d (window->window, &mask, \
                                &style->bg[ GTK_STATE_NORMAL ], _data)

#define build_pixmap_and_store_mask(_data, _mask) \
  gdk_pixmap_create_from_xpm_d (window->window, _mask, \
                                &style->bg[ GTK_STATE_NORMAL ], _data)

void pixmaps_init (void)
{
  GtkWidget *window;
  GtkStyle  *style;
  GdkBitmap *mask; /* useless but mandatory ;-) */

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_realize (window);

  style = gtk_widget_get_default_style ();

  /* Building Tool pixmaps */
  Tool_Pixmap[ 0 ] = build_pixmap (gem_xpm);
  Tool_Pixmap[ 1 ] = build_pixmap (target_xpm);
  Tool_Pixmap[ 2 ] = build_pixmap (wall_xpm);
  Tool_Pixmap[ 3 ] = build_pixmap (background_xpm);
  Tool_Pixmap[ 4 ] = build_pixmap (player_xpm);

  /* Building Control pixmaps */
  Control_Pixmap[ 0 ] = build_pixmap_and_store_mask (first_xpm,      &Control_Mask[ 0 ]);
  Control_Pixmap[ 1 ] = build_pixmap_and_store_mask (backward5_xpm,  &Control_Mask[ 1 ]);
  Control_Pixmap[ 2 ] = build_pixmap_and_store_mask (backward_xpm,   &Control_Mask[ 2 ]);
  Control_Pixmap[ 3 ] = build_pixmap_and_store_mask (forward_xpm,    &Control_Mask[ 3 ]);
  Control_Pixmap[ 4 ] = build_pixmap_and_store_mask (forward5_xpm,   &Control_Mask[ 4 ]);
  Control_Pixmap[ 5 ] = build_pixmap_and_store_mask (last_xpm,       &Control_Mask[ 5 ]);
/*  Control_Pixmap[ 1 ] = build_pixmap_and_store_mask (backward10_xpm, &Control_Mask[ 1 ]); */
/*  Control_Pixmap[ 6 ] = build_pixmap_and_store_mask (forward10_xpm,  &Control_Mask[ 6 ]); */
/*  Control_Pixmap[ 8 ] = build_pixmap_and_store_mask (quit_xpm,       &Control_Mask[ 8 ]); */

  /* Building Case pixmaps */
  Case_Pixmap[ 0 ] = NULL;              /* incorrect code */
  Case_Pixmap[ 1 ] = Tool_Pixmap[ 3 ];  /* background     */
  Case_Pixmap[ 2 ] = Tool_Pixmap[ 4 ];  /* player         */
  Case_Pixmap[ 3 ] = Tool_Pixmap[ 2 ];  /* wall           */
  Case_Pixmap[ 4 ] = NULL;              /* incorrect code */
  Case_Pixmap[ 5 ] = Tool_Pixmap[ 0 ];  /* gem            */
  Case_Pixmap[ 6 ] = NULL;              /* incorrect code */
  Case_Pixmap[ 7 ] = NULL;              /* incorrect code */
  Case_Pixmap[ 8 ] = NULL;              /* incorrect code */
  Case_Pixmap[ 9 ] = Tool_Pixmap[ 1 ];  /* target         */
  Case_Pixmap[ 10] = build_pixmap (player_target_xpm); /* player on target code */
  Case_Pixmap[ 11] = NULL;              /* incorrect code */
  Case_Pixmap[ 12] = NULL;              /* incorrect code */
  Case_Pixmap[ 13] = build_pixmap (gem_target_xpm); /* gem on target code */

  Dialog_Pixmap[ DLG_HAND ] = build_pixmap_and_store_mask (HandOpen_xpm, &Dialog_Mask[ DLG_HAND ]);
  Dialog_Pixmap[ DLG_FISH ] = build_pixmap_and_store_mask (Fish_xpm,     &Dialog_Mask[ DLG_FISH ]);
  Dialog_Pixmap[ DLG_BEER ] = build_pixmap_and_store_mask (Beer_xpm,     &Dialog_Mask[ DLG_BEER ]);
  Dialog_Pixmap[ DLG_GUN  ] = build_pixmap_and_store_mask (Gun_xpm,      &Dialog_Mask[ DLG_GUN  ]);

  gtk_widget_destroy (window);
}

#if 0
int main (int argc, char *argv[])
{
  gtk_init (&argc, &argv);

  pixmaps_init ();

  {
    GtkWidget *window, *hbox, *pix;
    int i;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_signal_connect (GTK_OBJECT (window), "destroy",
                        GTK_SIGNAL_FUNC (gtk_exit), 0);

    hbox = gtk_hbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (window), hbox);

    for (i = 0; i < 5; i++)
    {
      pix = gtk_pixmap_new (Tool_Pixmap[ i ], NULL);
      gtk_box_pack_start (GTK_BOX (hbox), pix, TRUE, FALSE, 0);
    }

    for (i = 0; i < 9; i++)
    {
      pix = gtk_pixmap_new (Control_Pixmap[ i ], NULL);
      gtk_box_pack_start (GTK_BOX (hbox), pix, FALSE, FALSE, 0);
    }

    for (i = 0; i < 14; i++)
    {
      pix = gtk_pixmap_new (Case_Pixmap[ i ], NULL);
      gtk_box_pack_start (GTK_BOX (hbox), pix, TRUE, FALSE, 0);
    }

    gtk_widget_show_all(window);

    gtk_main ();
  }

  return 0;
}
#endif /* we don't need main */
